package com.inca.npbusi.saset.bms_sa_reconciliation;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CDefaultProgress;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CToolbar;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.MdeFrame;
import com.inca.np.gui.ste.Steframe;
import com.inca.np.gui.tbar.TButton;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.dataimport.ImpHelper;
import com.inca.npclient.system.Clientframe;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.npx.ste.CSteModelAp;
import com.inca.pubsrv.Entrychose;
import com.inca.pubsrv.NpbusiDBHelper;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.HeadlessException;
import java.awt.event.ActionListener;
import java.io.FileInputStream;
import java.util.Vector;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

public class Bms_sa_reconciliation_ste extends CSteModelAp {
   String entryid = "";
   String entryname = "";
   private int errorflag = 0;

   public String getEntryid() {
      return this.entryid;
   }

   public void setEntryid(String entryid) {
      this.entryid = entryid;
   }

   public String getEntryname() {
      return this.entryname;
   }

   public void setEntryname(String entryname) {
      this.entryname = entryname;
   }

   public Bms_sa_reconciliation_ste(CFrame frame) throws HeadlessException {
      super(frame, "对账领用单");
      this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
      this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
   }

   public String getTablename() {
      return "BMS_SA_RECONCILIATION_V";
   }

   public String getSaveCommandString() {
      return "com.inca.npbusi.saset.bms_sa_reconciliation.Bms_sa_reconciliation_ste.保存对账领用单";
   }

   protected int on_new(int row) {
      String entryid = this.getEntryid();
      String receivemanid = ClientUserManager.getCurrentUser().getUserid();
      this.setItemValue(row, "entryid", entryid);
      this.setItemValue(row, "userid", receivemanid);
      this.setItemValue(row, "rdate", NpbusiDBHelper.getSysdate());
      this.setItemValue(row, "HTOTAL", "0");
      this.setItemValue(row, "RTOTAL", "0");
      return super.on_new(row);
   }

   protected JPanel createSecondtoolbar() {
      JPanel jp = new JPanel(new BorderLayout());
      CToolbar c = new CToolbar();
      c.setLayout(new BorderLayout());
      jp.add(c);
      this.createPanel(jp, "South");
      return jp;
   }

   private void createPanel(JPanel jp, String postion) {
      CToolbar c = (CToolbar)jp.getComponent(0);
      JPanel tmp = new JPanel(new FlowLayout(0));
      this.createTButton(tmp, "快速查询医院使用单", "快速查询医院使用单", "快速查询医院使用单", 79, this);
      c.add(tmp, "South");
      this.createTButton(tmp, "快速查询销售单", "快速查询销售单", "快速查询销售单", 80, this);
      c.add(tmp, "South");
   }

   private void createTButton(JPanel jpanel, String title, String tips, String command, int keychar, ActionListener listener) {
      TButton item = null;
      item = new TButton(" " + title + " ");
      item.setToolTipText(tips);
      item.setActionCommand(command);
      item.addActionListener(listener);
      item.setMnemonic(keychar);
      item.setFocusable(false);
      item.setForeground(Color.blue);
      item.setFont(new Font("宋体", 0, 17));
      jpanel.add(item);
      jpanel.setBackground(jpanel.getComponent(0).getBackground());
   }

   protected int on_actionPerformed(String command) {
      String approvetime;
      if (command.equals("快速查询医院使用单")) {
         approvetime = this.getItemValue(this.getRow(), "RID");
         ((Steframe)Clientframe.getClientframe().runOp("3021", false)).getCreatedStemodel().doRetrieve("1=1 AND RID =" + approvetime + " ");
      }

      if (command.equals("快速查询销售单")) {
         approvetime = this.getItemValue(this.getRow(), "SALESID");
         MdeFrame frm = (MdeFrame)Clientframe.getClientframe().runOp("1070", false);
         CMdeModelAp mde = (CMdeModelAp)frm.getCreatedMdemodel();
         mde.setUsequerythread(false);
         mde.getMasterModel().doRetrieve("SALESID in (" + approvetime + ")");
      }

      if (command.equals("切换独立单元")) {
         if (this.getModifiedDbmodel().getRowCount() > 0) {
            this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
            return -1;
         } else {
            if (Entrychose.setUserEntryInfo(this.frame)) {
               this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
               this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
            }

            this.doRetrieve("entryid = -1");
            return 0;
         }
      } else {
         String rid;
         if (command.equals("医院使用单导入")) {
            approvetime = this.getItemValue(this.getRow(), "APPROVETIME");
            if (approvetime != null && !"".equals(approvetime)) {
               this.infoMessage("提示", "对账领用单已确定！");
               return -1;
            } else if (this.getRow() == -1) {
               this.infoMessage("提示", "请选择对账单进行导入！");
               return -1;
            } else {
               rid = this.getItemValue(this.getRow(), "rid");
               if (rid != null && !"".equals(rid)) {
                  this.doImpAction();
                  this.doRequery();
                  return 0;
               } else {
                  this.infoMessage("提示", "请选择对账单进行导入！");
                  return -1;
               }
            }
         } else {
            if (command.equals("模版下载")) {
               this.excelDownload();
            }

            if (command.equals("确定")) {
               if (!"1".equals(this.getApvalue("确定"))) {
                  this.infoMessage("提示", "没有权限");
                  return -1;
               } else {
                  approvetime = this.getItemValue(this.getRow(), "APPROVETIME");
                  if (approvetime != null && !"".equals(approvetime)) {
                     this.infoMessage("提示", "对账领用单已确定！");
                     return -1;
                  } else {
                     rid = this.getItemValue(this.getRow(), "RID");
                     String sql = "select * from HUSEMV_ORDER_DTL_V where rid =" + rid + " ";
                     RemotesqlHelper rh = new RemotesqlHelper();
                     DBTableModel model = null;
                     int val = 0;

                     try {
                        model = rh.doSelect(sql, 0, 200);
                        if (model == null || model.getRowCount() <= 0) {
                           this.infoMessage("提示", "医院使用单对码单没有数据，无需确定！");
                           return -1;
                        }

                        Integer allcount = model.getRowCount();
                        String ppSql = "select * from HUSEMV_ORDER_DTL_V where rid =" + rid + "  and USESTATUS = 2 ";
                        model = rh.doSelect(ppSql, 0, 200);
                        Integer auditCount = model.getRowCount();
                        if (allcount != auditCount) {
                           int wppCount = allcount - auditCount;
                           if (allcount == wppCount) {
                              this.infoMessage("提示", "医院使用单未对码，不能确定！");
                              return -1;
                           }

                           if (JOptionPane.showConfirmDialog((Component)null, "医院使用单有" + wppCount + "条数据未匹配，是否确定通过?", "确定", 0) != 0) {
                              return -1;
                           }
                        }

                        String shSql = "select * from HUSEMV_ORDER_DTL_V where rid =" + rid + "  and USESTATUS = 2  ";
                        model = rh.doSelect(shSql, 0, 200);
                        Integer shallcount = model.getRowCount();
                        String jeSql = "select * from HUSEMV_ORDER_DTL_V where rid =" + rid + "  and USESTATUS = 2  and HTOTAL <> ETOTAL ";
                        model = rh.doSelect(jeSql, 0, 200);
                        Integer jecount = model.getRowCount();
                        if (jecount <= 0) {
                           val = 0;
                        } else if (shallcount == jecount) {
                           val = 1;
                        } else {
                           val = 2;
                        }
                     } catch (Exception var15) {
                        Exception e = var15;
                        e.printStackTrace();
                     }

                     String isDzd = "N";
                     if (val > 0) {
                        if (val == 1 && JOptionPane.showConfirmDialog((Component)null, "金额不符，是否直接生成订单?", "确定", 0) != 0) {
                           return -1;
                        }

                        if (val == 2 && JOptionPane.showConfirmDialog((Component)null, "金额不符，是否直接生成订单? ", "确定", 0) != 0) {
                           return -1;
                        }
                     }

                     this.auditBmsSaReconciliation(rid, isDzd);
                     return 0;
                  }
               }
            } else {
               return super.on_actionPerformed(command);
            }
         }
      }
   }

   private void excelDownload() {
      String[] array = new String[]{"备货备注（移库单号）", "产品编码", "通用名", "规格", "单位", "数量", "单价", "金额", "批号", "生产日期", "有效期", "使用日期", "生产企业名称", "注册证号"};
      String s = "医院使用单导入模版";

      try {
         ImpHelper.createExcel(array, s);
         this.infoMessage("提示", "EXCEL模板生成完成，存放路径：C:/DatabaseExcel/");
      } catch (Exception var5) {
         Exception ex2 = var5;
         Exception ex = ex2;
         ex2.printStackTrace();
         this.errorMessage("错误", "生成EXCEL模板失败：" + ex.getMessage());
      }

   }

   private void auditBmsSaReconciliation(String rid, String isDzd) {
      String hid = this.getItemValue(this.getRow(), "HID");
      String storageid = this.getItemValue(this.getRow(), "storageid");
      String customname = this.getItemValue(this.getRow(), "customname");
      ClientRequest req = new ClientRequest();
      req.addCommand(new StringCommand("husemv_order_dtl.确定"));
      req.addCommand(new StringCommand(rid));
      req.addCommand(new StringCommand(hid));
      req.addCommand(new StringCommand(storageid));
      req.addCommand(new StringCommand(customname));
      req.addCommand(new StringCommand(isDzd));
      ServerResponse resp = null;

      try {
         resp = SendHelper.sendRequest(req);
         String sercmd = ((StringCommand)resp.commandAt(0)).getString();
         if (sercmd.startsWith("+OK")) {
            this.infoMessage("提示", "确定成功!");
            this.doRequery();
         } else {
            this.infoMessage("提示", "确定失败，原因:" + sercmd);
         }
      } catch (Exception var9) {
         Exception e = var9;
         e.printStackTrace();
      }

   }

   static DBTableModel createConfirmParamdbmodel() {
      Vector<DBColumnDisplayInfo> cols = new Vector();
      DBColumnDisplayInfo col = new DBColumnDisplayInfo("salesid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("message", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("autofix", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("autokeep", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("usestatus", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("confirmaname", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("confirmdate", "date");
      cols.add(col);
      col = new DBColumnDisplayInfo("confirmanid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("approveflag", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("allowfix", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("autofixraise", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("storageid", "number");
      cols.add(col);
      return new DBTableModel(cols);
   }

   private void doImpAction() {
      JFileChooser fDialog = new JFileChooser();
      int result = fDialog.showOpenDialog(this.frame);
      if (result == 0) {
         String str4 = fDialog.getSelectedFile().getPath();
         int tmp1 = str4.lastIndexOf(".");
         String tmp2 = str4.substring(tmp1 + 1);
         if (!"xls".equals(tmp2)) {
            this.infoMessage("提示", "选中的文件不是.xls类型，不能导入！");
            return;
         }

         String name = fDialog.getSelectedFile().getName();

         try {
            CDefaultProgress progress = new CDefaultProgress(this.frame);
            ServerThread thread = new ServerThread(progress, str4, name);
            thread.start();
            progress.show();
         } catch (Exception var9) {
            Exception e = var9;
            e.printStackTrace();
         }
      }

   }

   private int insertModel(DBTableModel xlsModel) throws Exception {
      ClientRequest req = new ClientRequest();
      DataCommand cmd = new DataCommand();
      cmd.setDbmodel(xlsModel);
      String rid = this.getItemValue(this.getRow(), "rid");
      String hid = this.getItemValue(this.getRow(), "hid");
      String storageid = this.getItemValue(this.getRow(), "storageid");
      req.addCommand(new StringCommand("husemv_order_dtl.使用单导入"));
      req.addCommand(cmd);
      req.addCommand(new StringCommand(rid));
      req.addCommand(new StringCommand(hid));
      req.addCommand(new StringCommand(storageid));
      ServerResponse resp = null;
      resp = SendHelper.sendRequest(req);
      String sercmd = ((StringCommand)resp.commandAt(0)).getString();
      if (!sercmd.startsWith("+OK")) {
         throw new Exception(sercmd);
      } else {
         return Integer.parseInt(((StringCommand)resp.commandAt(1)).getString());
      }
   }

   static Vector<DBColumnDisplayInfo> createTmpDBModel() {
      Vector<DBColumnDisplayInfo> infos = new Vector();
      DBColumnDisplayInfo info = null;
      info = new DBColumnDisplayInfo("HMOVEID", "varchar", "HMOVEID");
      infos.add(info);
      info = new DBColumnDisplayInfo("HGOODSCODE", "varchar", "HGOODSCODE");
      infos.add(info);
      info = new DBColumnDisplayInfo("HGOODSNAME", "varchar", "HGOODSNAME");
      infos.add(info);
      info = new DBColumnDisplayInfo("HGOODSTYPE", "varchar", "HGOODSTYPE");
      infos.add(info);
      info = new DBColumnDisplayInfo("HGOODSUSEUNIT", "varchar", "HGOODSUSEUNIT");
      infos.add(info);
      info = new DBColumnDisplayInfo("HGOODSQTY", "varchar", "HGOODSQTY");
      infos.add(info);
      info = new DBColumnDisplayInfo("HUNITPRICE", "varchar", "HUNITPRICE");
      infos.add(info);
      info = new DBColumnDisplayInfo("HAMOUNT", "varchar", "HAMOUNT");
      infos.add(info);
      info = new DBColumnDisplayInfo("HLOTNO", "varchar", "HLOTNO");
      infos.add(info);
      info = new DBColumnDisplayInfo("HPRODDATE", "varchar", "HPRODDATE");
      infos.add(info);
      info = new DBColumnDisplayInfo("HINVALIDDATE", "varchar", "HINVALIDDATE");
      infos.add(info);
      info = new DBColumnDisplayInfo("USEDATE", "varchar", "USEDATE");
      infos.add(info);
      info = new DBColumnDisplayInfo("HFACTORYNAME", "varchar", "HFACTORYNAME");
      infos.add(info);
      info = new DBColumnDisplayInfo("HREGISTDOCNO", "varchar", "HREGISTDOCNO");
      infos.add(info);
      info = new DBColumnDisplayInfo("rows", "varchar", "rows");
      infos.add(info);
      return infos;
   }

   private DBTableModel readXls(String path) throws Exception {
      this.errorflag = 0;
      DBTableModel xlsModel = null;

      try {
         HSSFWorkbook workbook = new HSSFWorkbook(new FileInputStream(path));
         HSSFSheet sheet = workbook.getSheetAt(0);
         int rows = sheet.getPhysicalNumberOfRows();
         Vector<DBColumnDisplayInfo> infos = createDBModel();
         xlsModel = new DBTableModel(infos);

         for(int r = 1; r < rows; ++r) {
            String value = "";
            HSSFRow row = sheet.getRow(r);
            if (row != null) {
               for(short c = 0; c < 42; ++c) {
                  HSSFCell cell = row.getCell(c);
                  if (cell != null) {
                     switch (cell.getCellType()) {
                        case 0:
                           value = "";
                           if (c != 6 && c != 7) {
                              value = value + (long)cell.getNumericCellValue();
                              break;
                           }

                           value = value + (float)cell.getNumericCellValue();
                           break;
                        case 1:
                           value = cell.getStringCellValue();
                           break;
                        case 2:
                           System.out.println("CELL_TYPE_FORMULA");
                           break;
                        default:
                           value = "";
                           System.out.println("default");
                     }
                  }

                  xlsModel.appendRow();
                  if (c == 0) {
                     xlsModel.setItemValue(r - 1, "HMOVEID", value);
                  }

                  if (c == 1) {
                     xlsModel.setItemValue(r - 1, "HGOODSCODE", value);
                  }

                  if (c == 2) {
                     xlsModel.setItemValue(r - 1, "HGOODSNAME", value);
                  }

                  if (c == 3) {
                     xlsModel.setItemValue(r - 1, "HGOODSTYPE", value);
                  }

                  if (c == 4) {
                     xlsModel.setItemValue(r - 1, "HGOODSUSEUNIT", value);
                  }

                  if (c == 5) {
                     xlsModel.setItemValue(r - 1, "HGOODSQTY", value);
                  }

                  if (c == 6) {
                     xlsModel.setItemValue(r - 1, "HUNITPRICE", value);
                  }

                  if (c == 7) {
                     xlsModel.setItemValue(r - 1, "HAMOUNT", value);
                  }

                  if (c == 8) {
                     xlsModel.setItemValue(r - 1, "HLOTNO", value);
                  }

                  if (c == 9) {
                     xlsModel.setItemValue(r - 1, "HPRODDATE", value);
                  }

                  if (c == 10) {
                     xlsModel.setItemValue(r - 1, "HINVALIDDATE", value);
                  }

                  if (c == 11) {
                     xlsModel.setItemValue(r - 1, "USEDATE", value);
                  }

                  if (c == 12) {
                     xlsModel.setItemValue(r - 1, "HFACTORYNAME", value);
                  }

                  if (c == 13) {
                     xlsModel.setItemValue(r - 1, "HREGISTDOCNO", value);
                  }

                  if (c == 14) {
                     xlsModel.setItemValue(r - 1, "rows", String.valueOf(rows));
                  }
               }
            }
         }

         xlsModel.fireTableDataChanged();
         return xlsModel;
      } catch (ArrayIndexOutOfBoundsException var12) {
         this.errorflag = 2;
         var12.printStackTrace();
         throw new Exception("-Error  导入文件不符合格式规范，导致导入错误！");
      } catch (Exception var13) {
         Exception e = var13;
         this.errorflag = 2;
         e.printStackTrace();
         throw e;
      }
   }

   static Vector<DBColumnDisplayInfo> createDBModel() {
      Vector<DBColumnDisplayInfo> infos = new Vector();
      DBColumnDisplayInfo info = null;
      info = new DBColumnDisplayInfo("HMOVEID", "varchar", "HMOVEID");
      infos.add(info);
      info = new DBColumnDisplayInfo("HGOODSCODE", "varchar", "HGOODSCODE");
      infos.add(info);
      info = new DBColumnDisplayInfo("HGOODSNAME", "varchar", "HGOODSNAME");
      infos.add(info);
      info = new DBColumnDisplayInfo("HGOODSTYPE", "varchar", "HGOODSTYPE");
      infos.add(info);
      info = new DBColumnDisplayInfo("HGOODSUSEUNIT", "varchar", "HGOODSUSEUNIT");
      infos.add(info);
      info = new DBColumnDisplayInfo("HGOODSQTY", "varchar", "HGOODSQTY");
      infos.add(info);
      info = new DBColumnDisplayInfo("HUNITPRICE", "varchar", "HUNITPRICE");
      infos.add(info);
      info = new DBColumnDisplayInfo("HAMOUNT", "varchar", "HAMOUNT");
      infos.add(info);
      info = new DBColumnDisplayInfo("HLOTNO", "varchar", "HLOTNO");
      infos.add(info);
      info = new DBColumnDisplayInfo("HPRODDATE", "varchar", "HPRODDATE");
      infos.add(info);
      info = new DBColumnDisplayInfo("HINVALIDDATE", "varchar", "HINVALIDDATE");
      infos.add(info);
      info = new DBColumnDisplayInfo("USEDATE", "varchar", "USEDATE");
      infos.add(info);
      info = new DBColumnDisplayInfo("HFACTORYNAME", "varchar", "HFACTORYNAME");
      infos.add(info);
      info = new DBColumnDisplayInfo("HREGISTDOCNO", "varchar", "HREGISTDOCNO");
      infos.add(info);
      info = new DBColumnDisplayInfo("rows", "varchar", "rows");
      infos.add(info);
      return infos;
   }

   protected String getEditablecolumns(int row) {
      String approvetime = this.getItemValue(row, "APPROVETIME");
      if (approvetime != null && !"".equals(approvetime)) {
         return "remark";
      } else {
         String qtytotal = this.getItemValue(row, "qtytotal");
         if (qtytotal != null && !"".equals(qtytotal)) {
            Integer total = Integer.valueOf(qtytotal);
            if (total > 0) {
               return "remark";
            }
         }

         return super.getEditablecolumns(row);
      }
   }

   protected int on_beforedel(int row) {
      String approvetime = this.getItemValue(this.getRow(), "APPROVETIME");
      String rid = this.getItemValue(this.getRow(), "rid");
      if (approvetime != null && !"".equals(approvetime)) {
         this.infoMessage("提示", "对账领用单已确定！");
         return -1;
      } else {
         int on_beforedel = super.on_beforedel(row);
         return on_beforedel;
      }
   }

   public String getHovOtherWheres(int row, String colname) {
      return super.getHovOtherWheres(row, colname);
   }

   protected String getOtherWheres() {
      String entryid = this.getEntryid();
      return " entryid = " + entryid;
   }

   public int on_beforesave() {
      return super.on_beforesave();
   }

   protected int on_checkrow(int row, DBTableModel model) {
      return super.on_checkrow(row, model);
   }

   class ServerThread extends Thread {
      CDefaultProgress progress = null;
      String xlsname = null;
      String xlspath = null;
      int count = 0;
      int succnum = 0;
      int failnum = 0;
      String errmess = null;

      public ServerThread(CDefaultProgress progress, String xlsname, String path) {
         this.progress = progress;
         this.xlsname = path;
         this.xlspath = xlsname;
      }

      public void run() {
         this.progress.appendMessage("开始读入EXCEL数据，请耐心等待......");

         try {
            DBTableModel dbmodel = Bms_sa_reconciliation_ste.this.readXls(this.xlspath);
            if (dbmodel == null) {
               this.progress.appendMessage("EXCEL数据读入失败，请检查EXCEL格式是否符合规范。");
               if (Bms_sa_reconciliation_ste.this.errorflag == 1) {
                  this.progress.appendMessage("EXCEL导入数据不能多于3000行，请分批导入");
               }
            } else if (Bms_sa_reconciliation_ste.this.errorflag == 0) {
               this.progress.appendMessage("读入已完成。");
               this.progress.appendMessage("开始导入数据，请耐心等待......");
               sleep(3000L);
               int checkRowCount = 0;
               Vector<DBColumnDisplayInfo> tmpinfos = Bms_sa_reconciliation_ste.createTmpDBModel();
               DBTableModel tmpdbmodel = new DBTableModel(tmpinfos);

               for(int k = 0; k < dbmodel.getRowCount(); ++k) {
                  tmpdbmodel.appendRow();
                  tmpdbmodel.setItemValue(checkRowCount, "HMOVEID", dbmodel.getItemValue(k, "HMOVEID"));
                  tmpdbmodel.setItemValue(checkRowCount, "HGOODSCODE", dbmodel.getItemValue(k, "HGOODSCODE"));
                  tmpdbmodel.setItemValue(checkRowCount, "HGOODSNAME", dbmodel.getItemValue(k, "HGOODSNAME"));
                  tmpdbmodel.setItemValue(checkRowCount, "HGOODSTYPE", dbmodel.getItemValue(k, "HGOODSTYPE"));
                  tmpdbmodel.setItemValue(checkRowCount, "HGOODSUSEUNIT", dbmodel.getItemValue(k, "HGOODSUSEUNIT"));
                  tmpdbmodel.setItemValue(checkRowCount, "HGOODSQTY", dbmodel.getItemValue(k, "HGOODSQTY"));
                  tmpdbmodel.setItemValue(checkRowCount, "HUNITPRICE", dbmodel.getItemValue(k, "HUNITPRICE"));
                  tmpdbmodel.setItemValue(checkRowCount, "HAMOUNT", dbmodel.getItemValue(k, "HAMOUNT"));
                  tmpdbmodel.setItemValue(checkRowCount, "HLOTNO", dbmodel.getItemValue(k, "HLOTNO"));
                  tmpdbmodel.setItemValue(checkRowCount, "HPRODDATE", dbmodel.getItemValue(k, "HPRODDATE"));
                  tmpdbmodel.setItemValue(checkRowCount, "HINVALIDDATE", dbmodel.getItemValue(k, "HINVALIDDATE"));
                  tmpdbmodel.setItemValue(checkRowCount, "USEDATE", dbmodel.getItemValue(k, "USEDATE"));
                  tmpdbmodel.setItemValue(checkRowCount, "HFACTORYNAME", dbmodel.getItemValue(k, "HFACTORYNAME"));
                  tmpdbmodel.setItemValue(checkRowCount, "HREGISTDOCNO", dbmodel.getItemValue(k, "HREGISTDOCNO"));
                  tmpdbmodel.setItemValue(checkRowCount, "rows", dbmodel.getItemValue(k, "rows"));
                  ++checkRowCount;
                  if (checkRowCount % 10000 == 0) {
                     tmpdbmodel.fireTableDataChanged();
                     this.progress.appendMessage("开始处理一批数据......请稍后......");
                     checkRowCount = 0;
                     this.failnum += Bms_sa_reconciliation_ste.this.insertModel(tmpdbmodel);
                     this.progress.appendMessage("已经处理： " + (k + 1) / 42 + "条数据......");
                     tmpdbmodel.clearAll();
                  }
               }

               if (tmpdbmodel.getRowCount() > 0) {
                  this.failnum += Bms_sa_reconciliation_ste.this.insertModel(tmpdbmodel);
                  tmpdbmodel.clearAll();
               }

               sleep(3000L);
               this.count = dbmodel.getRowCount();
               this.succnum = this.count - this.failnum;
               sleep(3000L);
            }

            dbmodel.clearAll();
         } catch (Exception var16) {
            Exception e = var16;
            e.printStackTrace();
            this.progress.appendMessage("导入过程出现异常:" + e.getMessage());
            Bms_sa_reconciliation_ste.this.errorflag = 9;
            this.errmess = e.getMessage();

            try {
               sleep(3000L);
            } catch (InterruptedException var15) {
               InterruptedException ee = var15;
               ee.printStackTrace();
            }
         } finally {
            if (Bms_sa_reconciliation_ste.this.errorflag == 0) {
               this.progress.appendMessage("导入成功！共导入 " + this.count / 42 + " 条数据，成功 " + this.succnum / 42 + " 条，失败 " + this.failnum + " 条。成功率：" + Float.valueOf((float)this.succnum) / Float.valueOf((float)this.count) * 100.0F + "%");
            } else if (Bms_sa_reconciliation_ste.this.errorflag == 1) {
               this.progress.appendMessage("-ERROR:一次最多导入3000行，请分批导入！");
            } else if (Bms_sa_reconciliation_ste.this.errorflag == 2) {
               this.progress.appendMessage("-ERROR:EXCEL格式不符合规范！");
            } else if (Bms_sa_reconciliation_ste.this.errorflag == 9) {
               this.progress.appendMessage("-ERROR:导入过程出现异常:" + this.errmess);
            }

            try {
               sleep(3000L);
            } catch (InterruptedException var14) {
               InterruptedException ex = var14;
               ex.printStackTrace();
            }

            this.progress.close();
            if (Bms_sa_reconciliation_ste.this.errorflag == 0) {
               Bms_sa_reconciliation_ste.this.infoMessage("提示", "导入成功！共导入 " + this.count / 42 + " 条数据，成功 " + this.succnum / 42 + " 条，失败 " + this.failnum + " 条。成功率：" + Float.valueOf((float)this.succnum) / Float.valueOf((float)this.count) * 100.0F + "%");
            } else if (Bms_sa_reconciliation_ste.this.errorflag == 1) {
               Bms_sa_reconciliation_ste.this.infoMessage("警告", "一次最多导入3000行，请分批导入！");
            } else if (Bms_sa_reconciliation_ste.this.errorflag == 2) {
               Bms_sa_reconciliation_ste.this.infoMessage("警告", "EXCEL格式不符合规范！");
            } else if (Bms_sa_reconciliation_ste.this.errorflag == 9) {
               Bms_sa_reconciliation_ste.this.infoMessage("错误", "导入过程出现异常:" + this.errmess);
            }

         }

      }
   }
}
